//*****************************************************************************
// external_variables.h 
// Project Name - Error Calculator
// Company Name- Zera India Private Limited.  
// Author - Rajesh Varma
// Date - 04/09/2017
// Revision - 0
// Remarks
//
//*****************************************************************************



#ifndef __variables_H
#define __variables_H

extern unsigned int disp_para_cnt;
extern unsigned int boot_cnt;
extern unsigned int Copy_error_calc;
extern unsigned int fout_intCount; 
extern unsigned int switch_press_S1;
extern unsigned int reset_count;



extern unsigned char Error_Display_Seq;
extern unsigned char single_flag,continuous_flag;
extern unsigned char SC_PULSE_Selection;
extern unsigned char DLMS_Read_Flag;
extern unsigned char transperent_mode;
extern unsigned char decimal_position;
extern unsigned char once_display_hdlc;
extern unsigned char Measuremnt_flag;
extern unsigned char start_measurement_flag,stop_measurement_flag;
extern unsigned char reset_flag,reset_count_flag;
extern unsigned char pulse_received;
extern unsigned char timer_start_flag,zero_flag;
extern unsigned char Switch_debounce_flag;
extern unsigned char boot_flag,Edit_Enable;
extern unsigned char display_flag;
extern unsigned char reset_count_flag;
extern unsigned char reset_status_flag;
extern unsigned char Freeze_position;
extern unsigned char start_edge_flag;


extern char pcBuffer[40];
extern char error_buff[9],C_error_buff[4];
extern char Higher_error_flag;
extern char Start_postion,End_postion;
extern char Received_ID;
extern char Eneterd_Slave_ID;
extern char Temp_arrray[7];
extern char edge_accuracy_switch;
extern char edge_buff[7],Edge_mode_flag;



extern double N_Must;
extern double error_calc;
extern double 	N_Actual;
extern double master_meter_constant;


extern volatile unsigned char measurement_status_flag;
extern volatile unsigned int pulse_count,temp_pulse;
extern volatile unsigned long Edge_count,C_Edge_count;





extern int x,i;
extern unsigned long  ulAnimPos, ulColor;



extern tContext sContext_Label;
extern tRectangle sRect_Label;
extern tContext sContext_Meas_set[6][2];
extern tRectangle sRect_Meas_set[6][2];


//*********Flags for various opertaions*******************//
struct Flags
{
	unsigned char Start_Pressed : 1;		 
	unsigned char Stop_Pressed : 1;			 
	unsigned char N_Actual_Ready : 1;		
	unsigned char Pulse_Received : 1;
	unsigned char Error_Screen : 1;
	unsigned char Data_Update : 1;
	unsigned char Error_Displyed_Once : 1;
	unsigned char Edgecount_Screen:1;
}; extern struct Flags  Flag;


struct Meter_postion
{
	char Slave_ID[2];		
	char Slave_ID_flash;
	char First_boot;
	
};
extern struct Meter_postion Meter_Place;

union Data_query
{
	char data_length[2];
	int data_value;			
	
};extern union Data_query Receive_Query_length;


//**********************************************************//


extern void boot_screen_Load(void);
extern void boot_screen_Load(void);
extern void Err_measure_Page_Fix_Graphics(void);
extern void Err_measure_Page_Update(void);
extern void Editbutton_Page_Fix_Graphics(void);
extern void Editbutton_Page_Update(void);
extern void Edgecount_Page_Fix_Graphics(void);
extern void Edgecount_Page_Update(void);


extern void calculate_error(void );
extern void single_measurement(void);
extern void value_trancation(unsigned char);
extern void start_measurment(void);
extern void Timer2_start(void);
extern void Switch_init(void);
extern void switch_sense(void);
extern void Fix_Graphics(void);
extern void Null_char_position(register unsigned char , char *);
extern void divide_display(void);
extern void Clean_divide_display(void);
														  
#endif

