//*****************************************************************************
// variables.h 
// Project Name - Error Calculator
// Company Name- Zera India Private Limited.  
// Author - Rajesh Varma
// Date - 04/09/2017
// Revision - 0
// Remarks
//*****************************************************************************

#ifndef __Variables_H
#define __Variables_H

unsigned int disp_para_cnt=0;
unsigned int boot_cnt;
unsigned int Copy_error_calc;
unsigned int fout_intCount; 
unsigned int switch_press_S1;
unsigned int reset_count;



unsigned char Error_Display_Seq;
unsigned char single_flag,continuous_flag;
unsigned char SC_PULSE_Selection=0;
unsigned char DLMS_Read_Flag;
unsigned char transperent_mode;
unsigned char decimal_position;
unsigned char once_display_hdlc;
unsigned char Measuremnt_flag;
unsigned char start_measurement_flag,stop_measurement_flag;
unsigned char reset_flag,reset_count_flag;
unsigned char pulse_received;
unsigned char timer_start_flag,zero_flag;
unsigned char Switch_debounce_flag;
unsigned char boot_flag,Edit_Enable;
unsigned char display_flag;
unsigned char reset_count_flag;
unsigned char reset_status_flag;
unsigned char Freeze_position;
unsigned char start_edge_flag;



char pcBuffer[40];
char error_buff[9],C_error_buff[4];
char Higher_error_flag;
char Start_postion,End_postion;
char Received_ID;
char Eneterd_Slave_ID;
char Temp_arrray[7];
char edge_accuracy_switch;
char edge_buff[7],Edge_mode_flag;



double N_Must;
double error_calc;
double 	N_Actual;
double master_meter_constant;


volatile unsigned char measurement_status_flag;
volatile unsigned int pulse_count,temp_pulse;
volatile unsigned long Edge_count,C_Edge_count;





int x,i;
unsigned long  ulAnimPos, ulColor;



tContext sContext_Label;
tRectangle sRect_Label;
tContext sContext_Meas_set[6][2];
tRectangle sRect_Meas_set[6][2];

//*********Flags for various opertaions*******************//
struct Flags
{
	unsigned char Start_Pressed : 1;		 
	unsigned char Stop_Pressed : 1;			 
	unsigned char N_Actual_Ready : 1;		
	unsigned char Pulse_Received : 1;
	unsigned char Error_Screen : 1;
	unsigned char Data_Update : 1;
	unsigned char Error_Displyed_Once : 1;
	unsigned char Edgecount_Screen:1;
	
}Flag;


struct Meter_postion
{

	char Slave_ID[2];			//2 Slave ID
	char Slave_ID_flash;
	char First_boot;

}Meter_Place;


union Data_query
{
	char data_length[2];
	unsigned int data_value;			
	
}Receive_Query_length;


//***********************************************************//



//Function defintion
void boot_screen_Load(void);
void Err_measure_Page_Fix_Graphics(void);
void Err_measure_Page_Update(void);
void Editbutton_Page_Fix_Graphics(void);
void Editbutton_Page_Update(void);
void Edgecount_Page_Fix_Graphics(void);
void Edgecount_Page_Update(void);



void calculate_error(void );
void single_measurement(void);
void value_trancation(unsigned char);
void start_measurment(void);
void Timer2_start(void);
void Switch_init(void);
void switch_sense(void);
void Fix_Graphics(void);
void Null_char_position(register unsigned char , char *);
void divide_display(void);
void Clean_divide_display(void);


#endif





